// Harvester Map: Desert of Ice
//
// Two teams, two bases each, The smaller housing a teleporter base, the larger the AiBuilders.
// Both bases have turret, refinery and expansion builders. All spawnpoints area at the larger (farther away) base.
// Supply Dumps at both bases. One Zen pad in the center to fight over. Red team can only build Human AI, Blue
// can only build Cybrid AI. Designed to show off the many options in Harvester.
//
// ][)ull WR  11-23-00
//========================


function setHarvestVariables()
{

$Planet = "Snow"; 

$orePatches = 7;

$OreZones = 6;
$Xlow[1] = -4000;
$Xhigh[1] = -500; 
$Ylow[1] = -500;
$Yhigh[1] = 4000;

$Xlow[2] = -4000;
$Xhigh[2] = -1250; 
$Ylow[2] = -1500;
$Yhigh[2] = -500;

$Xlow[3] = -4000;
$Xhigh[3] = -500; 
$Ylow[3] = -4000;
$Yhigh[3] = -1500;

$Xlow[4] = 500;
$Xhigh[4] = 4000; 
$Ylow[4] = -4000;
$Yhigh[4] = -2000;

$Xlow[5] = 0;
$Xhigh[5] = 4000; 
$Ylow[5] = -2000;
$Yhigh[5] = 1500;

$Xlow[6] = 500;
$Xhigh[6] = 4000; 
$Ylow[6] = 1500;
$Yhigh[6] = 4000;

$BlueMarkers = 2; 
$RedMarkers = 2; 

$BlueMarker[1] = getObjectId("MissionGroup\\BLUE\\BaseNav"); 
$RedMarker[1] = getObjectId("MissionGroup\\RED\\BaseNav"); 
$BlueMarker[2] = getObjectId("MissionGroup\\BlueTPbase\\BaseNav"); 
$RedMarker[2] = getObjectId("MissionGroup\\RedTPbase\\BaseNav"); 

$BlueRadius[1] = 700;
$RedRadius[1] = 700;
$BlueRadius[2] = 300;
$RedRadius[2] = 300;

$NewBaseRadius = 300;


$orePatch[1] = getObjectId("MissionGroup\\oreTriggers\\OreTrigger1");
$orePatch[1].size = 100;
$orePatch[1].maxOre = 700;
$orePatch[1].maxRocks = 7;

$orePatch[2] = getObjectId("MissionGroup\\oreTriggers\\OreTrigger2");
$orePatch[2].size = 100;
$orePatch[2].maxOre = 700;
$orePatch[2].maxRocks = 7;

$orePatch[3] = getObjectId("MissionGroup\\oreTriggers\\OreTrigger3");
$orePatch[3].size = 100;
$orePatch[3].maxOre = 700;
$orePatch[3].maxRocks = 7;

$orePatch[4] = getObjectId("MissionGroup\\oreTriggers\\OreTrigger4");
$orePatch[4].size = 100;
$orePatch[4].maxOre = 700;
$orePatch[4].maxRocks = 7;

$orePatch[5] = getObjectId("MissionGroup\\oreTriggers\\OreTrigger5");
$orePatch[5].size = 100;
$orePatch[5].maxOre = 700;
$orePatch[5].maxRocks = 7;

$orePatch[6] = getObjectId("MissionGroup\\oreTriggers\\OreTrigger6");
$orePatch[6].size = 100;
$orePatch[6].maxOre = 700;
$orePatch[6].maxRocks = 7;

$orePatch[7] = getObjectId("MissionGroup\\oreTriggers\\OreTrigger7");
$orePatch[7].size = 100;
$orePatch[7].maxOre = 700;
$orePatch[7].maxRocks = 7;



$SiloDTS[*IDSTR_TEAM_BLUE] = "hmoonrefinery.dts";
$SiloDTS[*IDSTR_TEAM_RED] = "hmoonrefinery.dts";

$Silo[*IDSTR_TEAM_BLUE] = getObjectId("Missiongroup\\BLUE\\nukeBuilder");
$Silo[*IDSTR_TEAM_RED] = getObjectId("Missiongroup\\RED\\nukeBuilder");

$SiloX[*IDSTR_TEAM_BLUE] = 35.7;
$SiloY[*IDSTR_TEAM_BLUE] = 3443.9;
$SiloZ[*IDSTR_TEAM_BLUE] = 155.3;
$SiloZRot[*IDSTR_TEAM_BLUE] = 105;
$SiloXRot[*IDSTR_TEAM_BLUE] = 0;

$SiloX[*IDSTR_TEAM_RED] = -363.2;
$SiloY[*IDSTR_TEAM_RED] = -2971.6;
$SiloZ[*IDSTR_TEAM_RED] = 222.9;
$SiloZRot[*IDSTR_TEAM_RED] = 0;
$SiloXRot[*IDSTR_TEAM_RED] = 0;

 //Shrike Missile Husks for the bombs
$Bomb[*IDSTR_TEAM_BLUE] = getObjectId("Missiongroup\\blueBomb");
$Bomb[*IDSTR_TEAM_RED] = getObjectId("Missiongroup\\redBomb");

focusServer();
 //Waypoints (Put them where they are placed in this map in relation to the bases)
$Waypoints[*IDSTR_TEAM_BLUE] = getObjectId("Missiongroup/blueWaypoints");
$Waypoints[*IDSTR_TEAM_RED] = getObjectId("Missiongroup/redWaypoints");
$Waypoint[*IDSTR_TEAM_BLUE] = getObjectId("Missiongroup/blueWaypoints/Waypoint1");
$Waypoint[*IDSTR_TEAM_RED] = getObjectId("Missiongroup/redWaypoints/Waypoint1");
$Waypoint2[*IDSTR_TEAM_BLUE] = getObjectId("Missiongroup/blueWaypoints/Waypoint2");
$Waypoint2[*IDSTR_TEAM_RED] = getObjectId("Missiongroup/redWaypoints/Waypoint2");
unfocus();
   
 //PodExplosion Animations (Buzzbum MOD - FX Shapes)
$Explosion[*IDSTR_TEAM_BLUE] = getObjectId("Missiongroup\\blueExplosion");
$Explosion[*IDSTR_TEAM_RED] = getObjectId("Missiongroup\\redExplosion");
   
 //Thumper Animations (Buzzbum MOD - FX Shapes)
$Shockwave[*IDSTR_TEAM_BLUE] = getObjectId("Missiongroup\\blueShock");
$Shockwave[*IDSTR_TEAM_RED] = getObjectId("Missiongroup\\redShock");

// Starting Point for the dracos. Atop a launchpad or whatever.
$DracoX[*IDSTR_TEAM_BLUE] = 29.3;
$DracoY[*IDSTR_TEAM_BLUE] = 3383.3;
$DracoZ[*IDSTR_TEAM_BLUE] = 164;
$DracoX[*IDSTR_TEAM_RED] = -383.9;
$DracoY[*IDSTR_TEAM_RED] = -2895.5;
$DracoZ[*IDSTR_TEAM_RED] = 240.1;
}

//===========Stuff copied and edited from Mike The Goad's "Move It"============================

function HarvVehicleOnDestroyed(%destroyed, %destroyer)
{
if(%destroyed == $rm)
 {
 $rm = "";
 pr();
 }
if(%destroyed == $bm)
 {
 $bm = "";
 pb();
 }
}


//=== Red

function RedGen::structure::onScan(%this,%scanner)	// Red mobile nav porter
{
if($rm == "")
 {
 $rm = %scanner;					//new global 
 %p=playerManager::vehicleIdToPlayerNum(%scanner);
 say(%p,0,"Scan again to place nav-porter"); 
 mr();
 }
 else
 {
 $rm = "";
 }
}

function mr()
{
%x = (getPosition($rm,x) - 75);
%y = getPosition($rm,y);
%z = getPosition($rm,z);
if(%x == %z)					// he died or left
 {
 $rm = "";
 pr();
 }
 else
 {
 setPosition("missionGroup\\RedMove\\Frame",%x,%y,%z);
 %gz = (%z + 12.7);
 setPosition("missionGroup\\RedMove\\redGen",%x,%y,%gz);
 setPosition("missionGroup\\RedMove\\NavPorter",%x,%y,%z);
 }
if($rm != "")
 {
 schedule("mr();",0.2);
 }
 else
 {
 pr();
 }
}

function pr()
{
%x = getPosition("MissionGroup\\RedMove\\Frame",x);
%y = getPosition("MissionGroup\\RedMove\\Frame",y);
%h = (getTerrainHeight(%x,%y) - 0.5);
setPosition("missionGroup\\RedMove\\Frame",%x,%y,%h);
%gz = (%h + 12.7);
setPosition("missionGroup\\RedMove\\redGen",%x,%y,%gz);
setPosition("missionGroup\\RedMove\\NavPorter",%x,%y,%h);
}


//=== Blue

function BlueGen::structure::onScan(%this,%scanner)	// Blue mobile nav porter
{
if($bm == "")
 {
 $bm = %scanner;					//new global 
 %p=playermanager::vehicleIdToPlayerNum(%scanner);
 say(%p,0,"Scan again to place nav-porter"); 
 mb();
 }
 else
 {
 $bm = "";
 }
}

function mb()
{
%x = (getPosition($bm,x) - 75);
%y = getPosition($bm,y);
%z = getPosition($bm,z);
if(%x == %z)					// he died or left
 {
 $bm = "";
 pb();
 }
 else
 {
 setPosition("missionGroup\\BlueMove\\Frame",%x,%y,%z);
 %gz = (%z + 12.7);
 setPosition("missionGroup\\BlueMove\\BlueGen",%x,%y,%gz);
 setPosition("missionGroup\\BlueMove\\NavPorter",%x,%y,%z);
 }
if($bm != "")
 {
 schedule("mb();",0.2);
 }
 else
 {
 pb();
 }
}

function pb()
{
%x = getPosition("MissionGroup\\BlueMove\\Frame",x);
%y = getPosition("MissionGroup\\BlueMove\\Frame",y);
%h = (getTerrainHeight(%x,%y) - 0.5);
setPosition("missionGroup\\BlueMove\\Frame",%x,%y,%h);
%gz = (%h + 12.7);
setPosition("missionGroup\\BlueMove\\BlueGen",%x,%y,%gz);
setPosition("missionGroup\\BlueMove\\NavPorter",%x,%y,%h);
}

//=======================================================================


$MapVersion = "ver01.5 - 11-23-00";
$MapBy = "<F4>Harv_Desert_of_Ice by Dull@WolfsRangers.com";
exec("Harvest_StdLib_26.cs");
$missionName = "Desert_of_Ice -" @ $HarvStdLibVer;


function NavPorter::trigger::onEnter(%trigger, %vehicle)
{
%player = playerManager::vehicleIdToPlayerNum(%vehicle);
%markerId = getVehicleNavMarkerId(%vehicle);
if(%markerId == "") { say(%player, 0, "You must set a Nav-point to use the Nav-porter"); return; }
%x = getPosition(%markerId,x);
%y = getPosition(%markerId,y);
%z = getPosition(%markerId,z)+20;
setPosition(%vehicle, %x, %y, %z);

for(%i=1; %i<=%vehicle.Guards; %i++)
 {
 %j = %vehicle.Guard[%i];
 %tX = (randomInt(-50, 50) + %x);
 %tY = (randomInt(-50, 50) + %y);
 %tz = %z;
 while(getTerrainHeight(%tX, %tY) > %tz) { %tz = %tz + 5; }
 setPosition( %j, %tx, %ty, %tz);
 }
}


function NPortDes::structure::onScan(%statue, %vehicle)
{
%player = playerManager::vehicleIdToPlayerNum(%vehicle);
if(%player == 0) return;
say(%player, 35, "<F4>This is a nav-porter, set a nav marker and go through the portal to be warped to your nav marker. Setting nav markers with the ovehead map is recommended.");
}


function ZenPad::trigger::onEnter(%trigger, %vehicle)
{ Zen::onEnter(%trigger, %vehicle, *IDMULT_CHAT_ALLPAD, true, true); }

function ZenPad::trigger::onContact(%trigger, %vehicle)
{ Zen::work(%trigger, %vehicle, 100, 5, 0, true); }

function ZenPad::trigger::onLeave(%trigger, %vehicle)
{ Zen::onLeave(%trigger, %vehicle); }



// From MultiplayerStdLib, trimmed (and don't want most of that stuff, as the script is long enough as it is)

function Zen::onEnter(%trigger, %object, %message, %isReady, %countdown)
{
   if(%message != "")
   {
      %output = %message;
      %soundFile = "";
      if(%message == *IDMULT_CHAT_HEALPAD)
      {
         %soundFile = "repair_ent.wav";
      }
      else if(%message == *IDMULT_CHAT_AMMOPAD)
      {
         %soundFile = "reload_ent.wav";
      }
      
      if(%isReady == true)
      {
         %output = %output @ " ";
         if(
            %trigger.wait == false ||
            %trigger.wait == "" ||
            (%trigger.reset <= getCurrentTime())    
         )
         {
            %output = %output @ *IDMULT_READY; 
         }
         else
         {
            %output = %output @ *IDMULT_NOT_READY;
            
            if(
               %countdown == true &&   
               %trigger.reset != ""  
            )
            {
               %output = %output @ " " @ *IDMULT_READY_IN_1;
               %remaining = timeDifference(%trigger.reset, getCurrentTime());
               %output = %output @ %remaining @ *IDMULT_READY_IN_2;            
            }         
         }
      }
      %player = playerManager::vehicleIdToPlayerNum(%object);
      if(%player != 0)
      {
         say(%player, %trigger, %output, %soundFile);
      }
   }
}

function Zen::onLeave(%trigger, %object)
{
   if(%object == %trigger.special)
   {
      %trigger.special.pad = "";
      %trigger.special = "";
   }
}

function Zen::work(%trigger, %object, %healRate, %ammoRate, %reset, %shutdown)
{
   if(
      (
         isShutDown(%object) == true || 
         %shutdown == false 
      ) &&
      (
         %trigger.wait == false ||   
         %trigger.wait == "" ||
         %trigger.special == %object 
      ) &&
      (
         %trigger.depleted == "" ||  
         %trigger.depleted == false
      )
   )   
   {
      if(%healRate > 0)
      {
         healObject(%object, %healRate);
      }
      
      if(%ammoRate > 0)
      {   
         reloadObject(%object, %ammoRate);
      }

      if(
         %reset > 0 && 
         %trigger.reset == "" 
      )
      {      
         %trigger.special = %object;
         %object.pad = %trigger; 
         schedule("Zen::depleted(" @ %trigger @ ");", (%reset / 3));
         %trigger.reset = schedule("Zen::recharged(" @ %trigger @ ");", %reset);
         %trigger.wait = true;
      }
   }
   else
   {
      if(
         %object == %trigger.special && 
         %shutdown == true &&           
         isShutDown(%object) == false   
      )
      {
         %trigger.special.pad = "";
         %trigger.special = "";      
      }
   }
}

function box::structure::onDestroyed(%box, %destroyer)
{
schedule("damageArea("@%box@", 0, 0, 0, 40, 10000);", 1.5);
}